/*
**************************************
*       INEL 4206 - Micro I          *
*        Problem Set 3               *
*     Due on : April 15, 2003        *
*    University of Puerto Rico       *
*        Mayaguez Campus             *
*    Prepared by: Armando Marin      *
************************************** 
* Filename: p3.c                     *
* Descpription:                      *
*   C example file for problem 3     *
*                                    *
************************************** 
*/

#include<stdio.h> /* Contains Input/Output methods */
  



/* Forward declaration of the horner procedure */

int horner(int x, int i, int max, int poly[]);

/* Main program handler */

int main(void){

  /*  N = degree of polynomial */
  int N = 4;
  
  /*  Array containing polynomial coeficients with their place indicated
      by its reference index */
  int polynomial[5]={3,4,6,8,1};


  /*  Value of x for this polinomial */
  int x = 3;
  
  /* Call the horner procedure, with parameters 0 and N, store result
     in variable named result */
  int result=horner(x,0,N,polynomial);
  /* Print variable named result */

  printf("Result = %d \n",result);

}
  



/* 
   Definition of horner function, it takes four parameters:
   x = value of x for this run
   i = index of the term to be evaluated in this call to the horner
   function (ie. i=1, refers to term with x^1 or simply x 
   max = maximum index value (degree of the polynomial) 
   poly = arrar base address
*/

int horner(int x, int i, int max, int poly[]){
  /* Separate space to store any results we receive */

  int received_result = 0;

  /* Check for recursion end condition (stop condition), which is when
     i has reached the maximum value */

  if(i == max){
    /* return coefficient poly[max] */

    return poly[i];
  }

  else{
    /* call horner with the next index, store result in
       received_result */
    received_result = horner(x,i+1, max, poly);

    /* multiply the result by x */
    received_result = received_result * x; 

    /* add the product of horner(x,i+1, max, poly)* x with the value of
       poly[i], and return result */
    received_result = received_result + poly[i];
    return received_result;
  }
}
